package com.gonesnowboarding.misc;

public class gsMath
{
	/** Returns a double rounded to the significant figures specified */
	public static double significantFigures(double number, int sf)
    {
		//no sf for 0 on computers
        if (number != 0)
		{
			int mark = (int)Math.pow(10,sf-1);   //work out point when you have the right SF
			boolean negative = false;
			int scale = 1;

			//negate if neagtive, to use the same algorithm
			if (number < 0)
			{
				number*=-1;
				negative = true;
			}

			//loop through (increase or decrease by 10) until we have the right SF above the decimal point then round)
			//then return the number to it's original state
			if (number < mark)
			{
				while (number * scale < mark)
					scale*=10;
				number = ((double) Math.round(number * scale) )/ scale;
			}
			else
			{
				//could also do (10^trunc(logbase10(number)))/mark
				while (number / 10 / scale > mark)
					scale*=10;
				number = ((double) Math.round(number / scale) )* scale;
			}

			if (negative)
				number*=-1;
            }
            return number;
      }
}
